//
//  ViewController.m
//  CheckMarkDemo
//
//  Created by 张日奎 on 2017/11/27.
//  Copyright © 2017年 bestdew. All rights reserved.
//

#import "ViewController.h"

static NSString *identifiter = @"我是一个复用标识";

@interface ViewController () <UITableViewDelegate, UITableViewDataSource>
{
    NSIndexPath *_selectionIndexPath; // 记录被选中行
}
@property (nonatomic, strong) UITableView *tableView;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self.view addSubview:self.tableView];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 20;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:identifiter forIndexPath:indexPath];
    if (indexPath == _selectionIndexPath) {
        /* UITableViewCell上的子控件是懒加载机制，只有当cell.accessoryType = UITableViewCellAccessoryCheckmark时，用于标记被选中的button才会创建*/
        cell.accessoryType = UITableViewCellAccessoryCheckmark;
        UIButton *checkMark = cell.subviews[2];
        [checkMark setImage:[UIImage imageNamed:@"danxuan_selected"] forState:UIControlStateNormal];
    } else {
        cell.accessoryType = UITableViewCellAccessoryNone;
    }
    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    cell.textLabel.text = [NSString stringWithFormat:@"%zd", indexPath.row];
    
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
    cell.accessoryType = UITableViewCellAccessoryCheckmark;
    _selectionIndexPath = indexPath; // 记录被选中cell的indexPath，防止复用出现问题
    
    UIButton *checkMark = cell.subviews[2];
    [checkMark setImage:[UIImage imageNamed:@"danxuan_selected"] forState:UIControlStateNormal];
    NSLog(@"选中时：%@", cell.subviews);
}

- (void)tableView:(UITableView *)tableView didDeselectRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [tableView cellForRowAtIndexPath:indexPath];
    cell.accessoryType = UITableViewCellAccessoryNone;
    NSLog(@"未选中时：%@", cell.subviews);
}

- (UITableView *)tableView
{
    if (!_tableView) {
        
        _tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 20, self.view.frame.size.width, self.view.frame.size.height - 20) style:UITableViewStylePlain];
        _tableView.delegate = self;
        _tableView.dataSource = self;
        [_tableView registerClass:[UITableViewCell class] forCellReuseIdentifier:identifiter];
    }
    return _tableView;
}

@end
